#version 330

in vec3 position;
in vec3 normal;
in vec2 uv;
in vec3 tangents;
in vec3 bitangents;

uniform mat4 projectionMatrix;
uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform vec3 camPosition;

//shader outputs to the fragment shader
out vec2 fUV;
out vec3 fPosition;
out vec3 toCamera;
out mat3 TBN;

//out vec3 vEyeSpacePosition;
//out vec3 vEyeSpaceNormal;

void main() {
	mat3 normalMatrix = transpose(mat3(inverse(modelMatrix)));
	mat3 mv3 = mat3(viewMatrix * modelMatrix);

	gl_Position = projectionMatrix * viewMatrix * modelMatrix * vec4(position,1);
	fUV = uv;

	vec3 normals = normalMatrix * normalize(normal);
	vec3 tangents = mv3 * normalize(tangents);
	vec3 bitangents = mv3 * normalize(bitangents);
	TBN = mat3(tangents, bitangents, normals);

	fPosition = (modelMatrix * vec4(position,1)).xyz;

	toCamera = normalize(vec3(camPosition - fPosition));
}

